
; Copyright 2021 ing. E. Th. van den Oosterkamp
;
; Example software for the book "BareMetal Amiga Programming" (ISBN 9798561103261)
;
; Permission is hereby granted, free of charge, to any person obtaining a copy 
; of this software and associated files (the "Software"), to deal in the Software 
; without restriction, including without limitation the rights to use, copy,
; modify, merge, publish, distribute, sublicense, and/or sell copies of the Software,
; and to permit persons to whom the Software is furnished to do so,
; subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in 
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
; INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
; PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
; HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
; OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


; Interrupt autovector offets

IRQ1	EQU	$64
IRQ2	EQU	$68
IRQ3	EQU	$6C
IRQ4	EQU	$70
IRQ5	EQU	$74
IRQ6	EQU	$78
IRQ7	EQU	$7C

; CIA addresses and offsets

CIAA	EQU	$BFE001
CIAB	EQU	$BFD000

PRA	EQU	$0
PRB	EQU	$100
DDRA	EQU	$200
DDRB	EQU	$300
TALO	EQU	$400
TAHI	EQU	$500
TBLO	EQU	$600
TBHI	EQU	$700
TODLO	EQU	$800
TODMID	EQU	$900
TODHI	EQU	$A00
SDR	EQU	$C00
ICR	EQU	$D00
CRA	EQU	$E00
CRB	EQU	$F00

CIAAPRA	   EQU	CIAA+PRA
CIAAPRB	   EQU	CIAA+PRB
CIAADDRA   EQU	CIAA+DDRA
CIAADDRB   EQU	CIAA+DDRB
CIAATALO   EQU	CIAA+TALO
CIAATAHI   EQU	CIAA+TAHI
CIAATBLO   EQU	CIAA+TBLO
CIAATBHI   EQU	CIAA+TBHI
CIAATODLO  EQU	CIAA+TODLO
CIAATODMID EQU	CIAA+TODMID
CIAATODHI  EQU	CIAA+TODHI
CIAASDR	   EQU	CIAA+SDR
CIAAICR	   EQU	CIAA+ICR
CIAACRA	   EQU	CIAA+CRA
CIAACRB	   EQU	CIAA+CRB

CIABPRA	   EQU	CIAB+PRA
CIABPRB	   EQU	CIAB+PRB
CIABDDRA   EQU	CIAB+DDRA
CIABDDRB   EQU	CIAB+DDRB
CIABTALO   EQU	CIAB+TALO
CIABTAHI   EQU	CIAB+TAHI
CIABTBLO   EQU	CIAB+TBLO
CIABTBHI   EQU	CIAB+TBHI
CIABTODLO  EQU	CIAB+TODLO
CIABTODMID EQU	CIAB+TODMID
CIABTODHI  EQU	CIAB+TODHI
CIABSDR	   EQU	CIAB+SDR
CIABICR	   EQU	CIAB+ICR
CIABCRA	   EQU	CIAB+CRA
CIABCRB	   EQU	CIAB+CRB

; Custom chip offsets

DMACONR	EQU	$002
VPOSR	EQU	$004
VHPOSR	EQU	$006
JOY0DAT	EQU	$00A
JOY1DAT	EQU	$00C
CLXDAT	EQU	$00E
ADKCONR	EQU	$010

DSKBYTR	EQU	$01A
INTENAR	EQU	$01C
INTREQR	EQU	$01E

DSKPT	EQU	$020
DSKLEN	EQU	$024

VPOSW	EQU	$02A
VHPOSW	EQU	$02C

BLTCON0	EQU	$040
BLTCON1	EQU	$042
BLTAFWM	EQU	$044
BLTALWM	EQU	$046
BLTCPT	EQU	$048
BLTCPTH	EQU	$048
BLTCPTL	EQU	$04A
BLTBPT	EQU	$04C
BLTBPTH	EQU	$04C
BLTBPTL	EQU	$04E
BLTAPT	EQU	$050
BLTAPTH	EQU	$050
BLTAPTL	EQU	$052
BLTDPT	EQU	$054
BLTDPTH	EQU	$054
BLTDPTL	EQU	$056
BLTSIZE	EQU	$058
BLTCON0L EQU	$05A
BLTSIZV	EQU	$05C
BLTSIZH	EQU	$05e
BLTCMOD	EQU	$060
BLTBMOD	EQU	$062
BLTAMOD	EQU	$064
BLTDMOD	EQU	$066

BLTCDAT	EQU	$070
BLTBDAT	EQU	$072
BLTADAT	EQU	$074

DENISEID EQU	$07C

DSKSYNC	EQU	$07E

COP1LC	EQU	$080
COP1LCH	EQU	$080
COP1LCL	EQU	$082
COP2LC	EQU   	$084
COP2LCH	EQU   	$084
COP2LCL	EQU   	$086
COPJMP1	EQU 	$088
COPJMP2	EQU	$08A

DMACON	EQU	$096

INTENA	EQU	$09A
INTREQ	EQU	$09C

ADKCON	EQU	$09E

DIWSTRT	EQU	$08E
DIWSTOP	EQU	$090
DDFSTRT	EQU	$092
DDFSTOP	EQU	$094

CLXCON	EQU	$098

AUD0LC	EQU	$0A0
AUD0LCH	EQU	$0A0
AUD0LCL	EQU	$0A2
AUD0LEN	EQU	$0A4
AUD0PER	EQU	$0A6
AUD0VOL	EQU	$0A8
AUD0DAT	EQU	$0AA
AUD1LC	EQU	$0B0
AUD1LCH	EQU	$0B0
AUD1LCL	EQU	$0B2
AUD1LEN	EQU	$0B4
AUD1PER	EQU	$0B6
AUD1VOL	EQU	$0B8
AUD1DAT	EQU	$0BA
AUD2LC	EQU	$0C0
AUD2LCH	EQU	$0C0
AUD2LCL	EQU	$0C2
AUD2LEN	EQU	$0C4
AUD2PER	EQU	$0C6
AUD2VOL	EQU	$0C8
AUD2DAT	EQU	$0CA
AUD3LC	EQU	$0D0
AUD3LCH	EQU	$0D0
AUD3LCL	EQU	$0D2
AUD3LEN	EQU	$0D4
AUD3PER	EQU	$0D6
AUD3VOL	EQU	$0D8
AUD3DAT	EQU	$0DA

BPL1PTH	EQU	$0E0
BPL1PTL	EQU	$0E2
BPL2PTH	EQU	$0E4
BPL2PTL	EQU	$0E6
BPL3PTH	EQU	$0E8
BPL3PTL	EQU	$0EA
BPL4PTH	EQU	$0EC
BPL4PTL	EQU	$0EE
BPL5PTH	EQU	$0F0
BPL5PTL	EQU	$0F2
BPL6PTH	EQU	$0F4
BPL6PTL	EQU	$0F6
BPL7PTH	EQU	$0F8
BPL7PTL	EQU	$0FA
BPL8PTH	EQU	$0FC
BPL8PTL	EQU	$0FE
BPLCON0	EQU	$100
BPLCON1	EQU	$102
BPLCON2	EQU	$104
BPLCON3	EQU	$106
BPL1MOD	EQU	$108
BPL2MOD	EQU	$10A
BPLCON4	EQU	$10C
CLXCON2	EQU	$10E

SPR0PTH	EQU	$120
SPR0PTL	EQU	$122
SPR1PTH	EQU	$124
SPR1PTL	EQU	$126
SPR2PTH	EQU	$128
SPR2PTL	EQU	$12A
SPR3PTH	EQU	$12C
SPR3PTL	EQU	$12E
SPR4PTH	EQU	$130
SPR4PTL	EQU	$132
SPR5PTH	EQU	$134
SPR5PTL	EQU	$136
SPR6PTH	EQU	$138
SPR6PTL	EQU	$13A
SPR7PTH	EQU	$13C
SPR7PTL	EQU	$13E

SPR0POS	EQU	$140
SPR0CTL	EQU	$142
SPR0DATA EQU	$144
SPR0DATB EQU	$146

COLOR0	EQU	$180
COLOR1	EQU	$182
COLOR2	EQU	$184
COLOR3	EQU	$186
COLOR4	EQU	$188
COLOR5	EQU	$18A
COLOR6	EQU	$18C
COLOR7	EQU	$18E
COLOR8	EQU	$190
COLOR9	EQU	$192
COLOR10	EQU	$194
COLOR11	EQU	$196
COLOR12	EQU	$198
COLOR13	EQU	$19A
COLOR14	EQU	$19C
COLOR15	EQU	$19E
COLOR16	EQU	$1A0
COLOR17	EQU	$1A2
COLOR18	EQU	$1A4
COLOR19	EQU	$1A6
COLOR20	EQU	$1A8
COLOR21	EQU	$1AA
COLOR22	EQU	$1AC
COLOR23	EQU	$1AE
COLOR24	EQU	$1B0
COLOR25	EQU	$1B2
COLOR26	EQU	$1B4
COLOR27	EQU	$1B6
COLOR28	EQU	$1B8
COLOR29	EQU	$1BA
COLOR30	EQU	$1BC
COLOR31	EQU	$1BE


DIWHIGH	EQU	$1E4
FMODE	EQU	$1FC


